import plotly.figure_factory as ff
import plotly.graph_objects as go
import plotly
import json
import os
from decimal import Decimal

dir_path = os.path.dirname(os.path.realpath(__file__))

logcolorscale = [
        [
          0,
          '#482878'
        ],
        [
          0.0001,
          '#482878'
        ],
        [
          0.001,
          '#31688e'
        ],
        [
          0.01,
          '#1f9e89'
        ],
        [
          0.1,
          '#6ece58'
        ],
        [
          1,
          '#fde725'
        ]
      ]

results = []
texts = []
devicesY = []
algorithmsX = [
  'SHA512withECDSA224', 'SHA512withECDSA256', 'SHA512withECDSA384', 'SHA512withECDSA521', 
  
  'SHA512withRSARSA768', 'SHA512withRSA1024', 
  'SHA512withRSA2048', 'SHA512withRSA3072', 'SHA512withRSA4096',
  
  'SHA512withRSA2048/PSS', 'SHA512withRSA3072/PSS']
benchmarkNames = [
  'benchmarkSHA512WithECDSA224', 'benchmarkSHA512WithECDSA256', 'benchmarkSHA512WithECDSA384', 'benchmarkSHA512WithECDSA521', 
  
  'benchmarkSHA512WithRSA768', 'benchmarkSHA512WithRSA1024', 
  'benchmarkSHA512WithRSA2048', 'benchmarkSHA512WithRSA3072', 'benchmarkSHA512WithRSA4096',
  
  'benchmarkSHA512WithRSA2048Pss', 'benchmarkSHA512WithRSA3072Pss']

benchmarkClassName = 'cz.vutbr.benchmark.AsymmetricVerifyBenchmark'

for device in os.listdir("{}/results".format(dir_path)):
    filePath = "{}/results/{}/result.json".format(dir_path, device)
    content = open(filePath, "r").read()
    devicesY.append(device)
    decoded = json.loads(content)
    benchmarkResults = decoded['benchmarks']
    result = []
    text = []
    for benchmarkName in benchmarkNames:
      for benchmark in benchmarkResults:
          if benchmark['className'] == benchmarkClassName and benchmark['name'] == benchmarkName:
              metric = benchmark['metrics']['timeNs']['median']
              result.append(metric/1000000)
              text.append('%.2f' % Decimal(metric/1000000))
              break
    results.append(result)
    texts.append(text)

fig = ff.create_annotated_heatmap(results, x=algorithmsX, y=devicesY, annotation_text=texts, colorscale='VIRIDIS', showscale = True)
fig.update_layout(
    xaxis_title="Algorithm",
    yaxis_title="Device",
    autosize=False,
    width=1280,
    height=720,
)
fig['layout']['xaxis']['side'] = 'bottom'
fig['data'][0]['colorbar'].tickformat = ",.1"
fig['data'][0]['colorbar'].ticksuffix = " ms"
fig.write_image("{}/pdf/asymmetric_key_verify_SHA512WithRSAandEC.pdf".format(dir_path))